"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.remove = void 0;
const tslib_1 = require("tslib");
const remove = ({ t, services }) => (r) => {
    const Request = t.Object(t.prop('id', t.Ref('BlockId')).options({
        title: 'Block ID',
        description: 'The ID of the block to delete.',
    }));
    const Response = t.obj;
    const Func = t.Function(Request, Response).options({
        title: 'Read Block',
        intro: 'Retrieves a block by ID.',
        description: 'Fetches a block by ID.',
    });
    return r.prop('blocks.remove', Func, ({ id }) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        yield services.blocks.remove(id);
        return {};
    }));
};
exports.remove = remove;
