import { applyPatch, validateOperations } from '../../json-patch';
export const definePatchRoutes = (r) => {
    const { t, system } = r;
    system.alias('JsonPatch', t.Array(t.any));
    const Func = t
        .Function(t.Object(t.prop('doc', t.any).options({
        title: 'A document',
        description: 'A JSON document to apply the patch to.',
    }), t.prop('patch', t.Ref('JsonPatch')).options({
        title: 'A JSON Patch',
        description: 'A JSON Patch to apply to the document.',
    })), t.Object(t.propOpt('doc', t.any).options({
        title: '',
        description: 'JSON CRDT document.',
    })))
        .options({
        title: 'Apply JSON Patch to a document',
        description: 'Applies a JSON Patch to a JSON document and returns the result.',
    });
    return r.prop('patch.apply', Func, async ({ doc, patch }) => {
        validateOperations(patch);
        const result = applyPatch(doc, patch, { mutate: true });
        return {
            doc: result,
        };
    });
};
