import { t } from '../system';
export const BlockId = t.str.options({
    title: 'Block ID',
    min: 6,
    max: 40,
});
export const BlockSeq = t.num.options({
    title: 'Block Sequence Number',
    gte: 0,
    format: 'i32',
});
export const Block = t.Object(t.prop('id', t.Ref('BlockId')), t.prop('seq', t.Ref('BlockSeq')), t.prop('created', t.num), t.prop('updated', t.num), t.prop('blob', t.bin));
export const BlockPatch = t.Object(t.prop('seq', t.num), t.prop('created', t.num), t.prop('blob', t.bin));
