"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createCaller = exports.createRouter = void 0;
const routes_1 = require("./routes");
const caller_1 = require("../../reactive-rpc/common/rpc/caller");
const Value_1 = require("../../reactive-rpc/common/messages/Value");
const ObjectValueCaller_1 = require("../../reactive-rpc/common/rpc/caller/ObjectValueCaller");
const system_1 = require("./system");
const ObjectValue_1 = require("../../json-type-value/ObjectValue");
const createRouter = (services) => {
    const router = ObjectValue_1.ObjectValue.create(system_1.system);
    const deps = {
        services,
        router,
        system: system_1.system,
        t: system_1.system.t,
    };
    return (0, routes_1.routes)(deps)(router);
};
exports.createRouter = createRouter;
const createCaller = (services) => {
    const router = (0, exports.createRouter)(services);
    const caller = new ObjectValueCaller_1.ObjectValueCaller({
        router,
        wrapInternalError: (error) => {
            if (error instanceof Value_1.RpcValue)
                return error;
            if (error instanceof caller_1.RpcError)
                return caller_1.RpcError.value(error);
            console.error(error);
            return caller_1.RpcError.valueFrom(error);
        },
    });
    return { router, caller };
};
exports.createCaller = createCaller;
