import { MemoryStore } from './MemoryStore';
import { StorePatch } from './types';
import type { Services } from '../Services';
export declare class BlocksServices {
    protected readonly services: Services;
    protected readonly store: MemoryStore;
    constructor(services: Services);
    create(id: string, patches: StorePatch[]): Promise<{
        block: import("./types").StoreBlock;
    }>;
    get(id: string): Promise<{
        block: import("./types").StoreBlock;
        patches: StorePatch[];
    }>;
    remove(id: string): Promise<void>;
    history(id: string, min: number, max: number): Promise<{
        patches: StorePatch[];
    }>;
    edit(id: string, patches: StorePatch[]): Promise<{
        block: import("./types").StoreBlock;
        patches: StorePatch[];
    }>;
    stats(): {
        blocks: number;
        patches: number;
    };
    private maybeGc;
    private gc;
}
